<?php

/**
 * @file
 * Provide views data and handlers for yahoomeme.module
 */

/**
 * @defgroup views_yahoomeme_module yahoomeme.module handlers
 */

/**
 * Implementation of hook_views_data()
 */
function yahoomeme_views_data() {
  //Basic Table Information

  $data['memepost']['table']['group'] = t('Yahoomeme');

  $data['memepost']['table']['base'] = array(
    'field' => 'meme_username',
    'title' => t('Yahoomeme post'),
    'help' => t('Yahoomeme post message'),
    'weight' => 11,
  );

  // Meme username
  $data['memepost']['meme_username'] = array(
    'title' => t('Meme Username'),
    'help' => t('The username of user yahoomeme account'),
    'field' => array(
      'handler' => 'yahoomeme_views_handler_field_username',
      'click sortable' => TRUE,
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),
  );

  $data['memepost']['created_time'] = array(
    'title' => t('Created time'),
    'help' => t('The time the memepost message was posted.'),
    'field' => array(
      'handler' => 'views_handler_field_date',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_date',
    ),
  );

  // Memepost Content
  $data['memepost']['content'] = array(
    'title' => t('Message Text'),
    'help' => t('The text of the meme message.'),
    'field' => array(
      'handler' => 'yahoomeme_views_handler_field_content',
      'click sortable' => TRUE,
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
  );

  // Post category
  $data['memepost']['category'] = array(
    'title' => t('Category'),
    'help' => t('The category of the memepost (text, photo, audio or video)'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),
  );

  // Caption
  $data['memepost']['caption'] = array(
      'title' => t('Caption'),
      'help' => t('Caption of the memepost.'),
      'field' => array(
        'handler' => 'views_handler_field_xss',
        'click sortable' => TRUE,
        ),    
      'filter' => array(
        'handler' => 'views_handler_filter_string',
        ),    
      'sort' => array(
        'handler' => 'views_handler_sort',
        ),    
      );    

  // Comment
  $data['memepost']['comment'] = array(
      'title' => t('Comment'),
      'help' => t('User Comment on the memepost.'),
      'field' => array(
        'handler' => 'views_handler_field_xss',
        'click sortable' => TRUE,
        ),    
      'filter' => array(
        'handler' => 'views_handler_filter_string',
        ),    
      'sort' => array(
        'handler' => 'views_handler_sort',
        ),    
      );    

  $data['memeuser']['table']['group'] = t('Yahoomeme account');

  $data['memeuser']['table']['join'] = array(
      'memepost' => array(
        'left_field' => 'meme_username',
        'field' => 'meme_username',
      ),
      'users' => array(
        'left_field' => 'uid',
        'field' => 'uid',
      ),
    );
  
  //Yahoomeme user drupal uid
  $data['memeuser']['uid'] = array(
    'title' => t('User ID'),
    'help' => t('The Drupal UID of user of the Yahoomeme account'),
  );

  //Yahoomeme username
  $data['memeuser']['meme_username'] = array(
    'title' => t('Username'),
    'help' => t('The username of the Yahoomeme user'),
    'field' => array(
      'handler' => 'yahoomeme_views_handler_field_username',
      'click sortable' => TRUE,
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'arguments' => array(
      'handler' => 'views_handler_argument_string',
    ),
  );

  // Yahoomeme usertitle (Full Name)
  $data['memeuser']['title'] = array(
    'title' => t('Full name'),
    'help' => t('The full name Yahoomeme account user'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),
  );

  // Yahoomeme account description
  $data['memeuser']['description'] = array(
    'title' => t('Description'),
    'help' => t('The description of the Yahoomeme account.'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'filter' => array(
      'handler' => 'views_handler_field_xss',
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
  );

  // Yahoomeme account follower count
  $data['memeuser']['followers'] = array(
    'title' => t('Followers'),
    'help' => t('The number of users following this Yahoomeme account'),
    'field' => array(
      'handler' => 'views_handler_field_numeric',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
    'sort' => array(
      'handler' => 'views_handler_sort'
    ),
  );

  // Yahoomeme account profile image
  $data['memeuser']['avatar_url'] = array(
    'title' => t('User Avatar'),
    'help' => t('The user profile image in yahoomeme.'),
    'field' => array(
      'handler' => 'yahoomeme_views_handler_field_profile_image',
      'click sortable' => TRUE,
    ),
  );
  // Last Checked for updates 
  $data['memeuser']['last_checked'] = array(
      'title' => t('Last Checked'),
      'help' => t('The time the Yahoomeme account statuses were retrieved.'),
      'field' => array(
        'handler' => 'views_handler_field_date',
        'click sortable' => TRUE,
        ),
      'sort' => array(
        'handler' => 'views_handler_sort',
        ),
      'filter' => array(
        'handler' => 'views_handler_filter_date',
        ),
      );

  return $data;
}

function yahoomeme_views_data_alter(&$data) {
  $data['users']['table']['join']['memepost'] = array(
    'left_table' => 'memeuser',
    'left_field' => 'uid',
    'field' => 'uid',
  );
  
  $data['users']['table']['join']['memeuser'] = array(
    'left_field' => 'uid',
    'field' => 'uid',
  );

}

/**
 * @}
 */
