<?php


class yahoomeme_views_handler_field_content extends views_handler_field {

  function option_definition() {
    $options = parent::option_definition();
    $options['height_max'] = array('default' => '');
    $options['width_max'] = array('default' => '');
    return $options;
  }
  
  function options_form(&$form, &$form_state) {
    parent::options_form($form, $form_state);
    $form['height_max'] = array(
      '#title' => t('Max height of photo meme'),
      '#type' => 'textfield',
      '#default_value' => $this->options['height_max'],
      '#description' => t('Leave this blank, if you dont want to scale the image.'),
    );
    $form['width_max'] = array(
      '#title' => t('Max width of photo meme'),
      '#type' => 'textfield',
      '#default_value' => $this->options['width_max'],
      '#description' => t('Leave this blank, if you dont want to scale the image.'),
    );
  }

  function construct() {
    parent::construct();
    $this->additional_fields['memepost_category'] = array(
      'field' => 'category',
    );
  }

  function render($values) {
    $value = $values->{$this->field_alias};
    $category = $values->memepost_category;
    if ($category == 'photo') {
      $attributes = array('height' => $this->options['height_max'], 'width' => $this->options['width_max'], 'align' => 'texttop');
      $output = theme('image', $value, '', '', $attributes, FALSE);
    }   
    else {
      $output = $value;
    } 
    return $output;
  }
}

class yahoomeme_views_handler_field_profile_image extends views_handler_field {
  function render($values) {
    $value = $values->{$this->field_alias};
    return theme('image', $value, '', '', array(), FALSE);
  }
}

class yahoomeme_views_handler_field_username extends views_handler_field {

  function option_definition() {
    $options = parent::option_definition();
    $options['link_memeaccount'] = array('default' => TRUE);
    return $options;
  }
  
  function options_form(&$form, &$form_state) {
    parent::options_form($form, $form_state);
    $form['link_memeaccount'] = array(
      '#title' => t('Link this field to meme account'),
      '#type' => 'checkbox',
      '#default_value' => $this->options['link_memeaccount'],
      '#description' => t('If checked, this field will be made into a link, to user yahoo meme account.'),
    );
  }

  function render($values) {
    $value = $values->{$this->field_alias};
    if ($this->options['link_memeaccount']) {
      $output = l($value, 'http://meme.yahoo.com/'.$value);  
    }   
    else {
      $output = $value;
    } 
    return $output;
  }
}
